package ecommerce;

import exceptions.DomainException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author  pfister
 */
public class Application {
	private List<Client> clients = new ArrayList<Client>();


	public Caddie addCaddie(Client client, double montant, String date)
			throws DomainException {
		Caddie toAdd = new Caddie(client, montant, date);
		return toAdd;
	}

	public Client addClient(String nom, String adresse) throws DomainException {
		Client toAdd = new Client(clients.size() + 1, nom, adresse);
		if (clients.contains(toAdd))
			throw new DomainException("le client existe dj");		
		clients.add(toAdd);
		return toAdd;
	}

	/**
	 * @return  the clients
	 * @uml.property  name="clients"
	 */
	public List<Client> getClients() {
		return clients;
	}

	public static void main(String[] args) {
		Application eCommerce = new Application();
		eCommerce.test();
	}

	@Override
	public String toString() {
		String result = "";
		result += "------clients-factures-------\n";
		Iterator clientIterator = clients.iterator();
		while (clientIterator.hasNext()) {
			Client client = (Client) clientIterator.next();
			result += client.toString() + "\n";
		}
		return result;
	}

	public void test() {
        load();
		System.out.print(this);
	}

	public void load() {
		try {


			Client client1 = addClient("Dupont", "10, rue des roses");
			Client client2 = addClient("Durand", "15, rue des lilas");

			Caddie caddie = addCaddie(client1, 100.0, "10/02/2005");
			caddie = addCaddie(client1, 200.0, "01/04/2005");
			caddie = addCaddie(client1, 300.0, "12/06/2006");
			caddie = addCaddie(client2, 250.0, "15/02/2000");
			caddie = addCaddie(client2, 350.0, "15/03/2000");
		

		} catch (DomainException e) {
			System.out.print(e.getMessage());
			e.printStackTrace();
		}
		
	}

	public void save() {
		// TODO Auto-generated method stub
		
	}


	
}
