package ecommerce;

import exceptions.DomainException;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

/**
 * @author  pfister
 */
public class Caddie {
	private static DateFormat myformat = new SimpleDateFormat("dd/MM/yyyy");

	//private List<Item> items = new ArrayList<Item>();

	private int id;

	private Client client;

	private double montant;

	private Date date;

	/**
	 * @return  the date
	 * @uml.property  name="date"
	 */
	public String getDate() {
		return myformat.format(date);
	}

	/**
	 * @return  the client
	 * @uml.property  name="client"
	 */
	public Client getClient() {
		return client;
	}

	/**
	 * @param client  the client to set
	 * @uml.property  name="client"
	 */
	public void setClient(Client client) {
		this.client = client;
	}

	/**
	 * @return  the id
	 * @uml.property  name="id"
	 */
	public int getId() {
		return id;
	}

	/**
	 * @param id  the id to set
	 * @uml.property  name="id"
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @return  the montant
	 * @uml.property  name="montant"
	 */
	public double getMontant() {
		double result = 0.0;
		/*
		if (items.size() == 0)
			result = montant;
		else {
			Iterator itemIterator = items.iterator();
			while (itemIterator.hasNext()) {
				Item item = (Item) itemIterator.next();
				result += item.getArticle().getPrix() * item.getQuantite();
			}
		} */
		return montant;
	}

	/**
	 * @param montant  the montant to set
	 * @uml.property  name="montant"
	 */
	public void setMontant(double montant) {
		this.montant = montant;
	}


	public Caddie(Client client, double montant, String date)
			throws DomainException {
		int id = client.getCaddies().size()+1;
		try {
			this.date = myformat.parse(date);
		} catch (ParseException e) {
			throw new DomainException("parse error for date: " + date);
		}
		this.id = id;
		this.client = client;
		if (montant < 0)
			throw new DomainException(
					" le montant ne peut tre ngatif (client)"
							+ client.getNom());
		this.montant = montant;
		client.getCaddies().add(this);
	}


	
	@Override
	public String toString() {
		String result = "  facture du "+getDate() + " montant: " + getMontant();	
		return result;
	}

}
