package web;

import java.io.IOException;
import java.util.Iterator;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import ecommerce.Application;
import ecommerce.Client;

public class Controleur extends javax.servlet.http.HttpServlet implements
		javax.servlet.Servlet {

	private Application application = new Application();

	@Override
	public void init() throws ServletException {
		super.init();
		application.load();
	}

	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {

		int id = -2;
		try {
			id = Integer.parseInt(request.getParameter("id"));
		} catch (Exception e) {

		}
		String action = request.getParameter("action");
		if ("modifier".equals(action))
			action = "update-client";
		if ("ajouter".equals(action))
			action = "create-client";
		if ("supprimer".equals(action))
			action = "delete-client";
		if ("rechercher".equals(action))
			action = "retrieve-client";

		if (id == -1 && "update-client".equals(action))
			action = "new-client";

		String etatSuivant = "index.jsp";

		if ("liste-clients".equals(action)) {
			List<Client> clients = application.getClients();
			request.setAttribute("listeclients", clients);
			etatSuivant = "listeclients.jsp";
		} else if ("edite-client".equals(action)) {
			try {
				request.removeAttribute("client");
				int clientId = Integer.parseInt(request.getParameter("id"));
				List<Client> clients = application.getClients();
				Iterator clientIterator = clients.iterator();
				while (clientIterator.hasNext()) {
					Client client = (Client) clientIterator.next();
					if (client.getId() == clientId)
						request.setAttribute("client", client);
				}
				etatSuivant = "formclient.jsp";
			} catch (Exception e) {

			}
		} else if ("update-client".equals(action)) {
			try {
				request.removeAttribute("client");
				int clientId = Integer.parseInt(request.getParameter("id"));
				List<Client> clients = application.getClients();
				Iterator clientIterator = clients.iterator();
				while (clientIterator.hasNext()) {
					Client client = (Client) clientIterator.next();
					if (client.getId() == clientId) {
						client.setNom(request.getParameter("nom"));
						client.setAdresse(request.getParameter("adresse"));
						request.setAttribute("client", client);
					}
				}
				etatSuivant = "formclient.jsp";
			} catch (Exception e) {

			}
		} 
		
		else if ("new-client".equals(action)) {
			request.removeAttribute("client");
			Client client = new Client(application.getClients().size() + 2,
					request.getParameter("nom"), request
							.getParameter("adresse"));
			application.getClients().add(client);
			request.setAttribute("client", client);
			etatSuivant = "formclient.jsp";
		} 
		
		else if ("create-client".equals(action)) {
			request.setAttribute("client", new Client(-1, "", ""));
			etatSuivant = "formclient.jsp";
		} 
		
		
		else if ("delete-client".equals(action)) {
			int clientId = Integer.parseInt(request.getParameter("id"));
			Client toRemove = null;
			List<Client> clients = application.getClients();
			Iterator clientIterator = clients.iterator();
			while (clientIterator.hasNext()) {
				Client client = (Client) clientIterator.next();
				if (client.getId() == clientId) {
					toRemove = client;
					break;
				}
			}
			if (toRemove != null) {
				application.getClients().remove(toRemove);
				request.removeAttribute("client");
				request.setAttribute("listeclients", application.getClients());
			}
			etatSuivant = "listeclients.jsp";
		}

		RequestDispatcher dispatcher = request
				.getRequestDispatcher(etatSuivant);
		dispatcher.forward(request, response);
	}

	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		doGet(request, response);
	}

	@Override
	public void destroy() {
		application.save();
		super.destroy();
	}

}